//+------------------------------------------------------------------+
//|                                        MTF tick newBar newZZ.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//-------------------------------------------------------------------
//MagicNumber sudarymas
//Pirmas skaicius- tai periodas
//jei 1 - PERIOD_M1, 
//jei 2 - PERIOD_M5, 
//jei 3 - PERIOD_M15, 
//jei 4 - PERIOD_M30,
//jei 5 - PERIOD_H1,
//jei 6 - PERIOD_H4,
//jei 7 - PERIOD_D1, 
//jei 8 - ERIOD_W1

extern int  MagicNumber    =  1000000;
//-------------------------------------------
// Ar naudosim siuos TF
//-------------------------------------------
extern bool tf_M1          =  true;
extern bool tf_M5          =  true;
extern bool tf_M15         =  true;
extern bool tf_M30         =  true;
extern bool tf_M60         =  true;
extern bool tf_M240        =  true;
extern bool tf_M1440       =  true;
extern bool tf_M10080      =  true;
//-------------------------------------------
// Liniju spalvos kiekvienam TF
//-------------------------------------------
extern color c_M1          =  Silver;
extern color c_M5          =  Red;
extern color c_M15         =  Yellow;
extern color c_M30         =  Blue;
extern color c_M60         =  Green;
extern color c_M240        =  BurlyWood;
extern color c_M1440       =  Maroon;
extern color c_M10080      =  Aqua;
//-------------------------------------------
// Liniju storiai kiekvienam TF
//-------------------------------------------
extern int  width_M1       =  1;
extern int  width_M5       =  1;
extern int  width_M15      =  2;
extern int  width_M30      =  3;
extern int  width_M60      =  4;
extern int  width_M240     =  5;
extern int  width_M1440    =  1;
extern int  width_M10080   =  1;
//------------------------------------------
// TF masyvas
//------------------------------------------
int         TimeFrame[8]   = {PERIOD_M1, 
                              PERIOD_M5, 
                              PERIOD_M15, 
                              PERIOD_M30,
                              PERIOD_H1,
                              PERIOD_H4,
                              PERIOD_D1, 
                              PERIOD_W1};
int         tf;
//------------------------------------------------------------
// HL kanalo globalus kintamieji ir pirminiai duomenys 
//------------------------------------------------------------
extern bool Ch_isDraw         = false;
extern int  Ch_max_M1         = 20;
extern int  Ch_max_M5         = 300;
extern int  Ch_max_M15        = 20;
extern int  Ch_max_M30        = 20;
extern int  Ch_max_M60        = 20;
extern int  Ch_max_M240       = 20;
extern int  Ch_max_M1440      = 20;
extern int  Ch_max_M10080     = 20;
extern int  minBars_M1        = 20;
extern int  minBars_M5        = 60;
extern int  minBars_M15       = 20;
extern int  minBars_M30       = 20;
extern int  minBars_M60       = 20;
extern int  minBars_M240      = 20;
extern int  minBars_M1440     = 20;
extern int  minBars_M10080    = 20;
double      Ch_H              = 0;
double      Ch_L              = 0;
double      Ch                = 0;
datetime    StartTime         = 0;
datetime    EndTime           = 0;
int         k                 = 0;
//------------------------------------------------------------
// Pirminiai duomenu nustatymai ieskant ZZ kanalo-veduokles
//------------------------------------------------------------
datetime    CurrTime1         =  0,
            CurrTime5         =  0,
            CurrTime15        =  0,
            CurrTime30        =  0,
            CurrTime60        =  0,
            CurrTime240       =  0,
            CurrTime1440      =  0,
            CurrTime10080     =  0;
datetime    PrevTime1         =  0,
            PrevTime5         =  0,
            PrevTime15        =  0,
            PrevTime30        =  0,
            PrevTime60        =  0,
            PrevTime240       =  0,
            PrevTime1440      =  0,
            PrevTime10080     =  0;
datetime    CurrLineTime1     =  0,
            CurrLineTime5     =  0,
            CurrLineTime15    =  0,
            CurrLineTime30    =  0,
            CurrLineTime60    =  0,
            CurrLineTime240   =  0,
            CurrLineTime1440  =  0,
            CurrLineTime10080 =  0;
datetime    PrevLineTime1     =  0,
            PrevLineTime5     =  0,
            PrevLineTime15    =  0,
            PrevLineTime30    =  0,
            PrevLineTime60    =  0,
            PrevLineTime240   =  0,
            PrevLineTime1440  =  0,
            PrevLineTime10080 =  0;
double      PrevZZ1           =  0,
            PrevZZ5           =  0,
            PrevZZ15          =  0,
            PrevZZ30          =  0,
            PrevZZ60          =  0,
            PrevZZ240         =  0,
            PrevZZ1440        =  0,
            PrevZZ10080       =  0;
double      CurrZZ1           =  0,
            CurrZZ5           =  0,
            CurrZZ15          =  0,
            CurrZZ30          =  0,
            CurrZZ60          =  0,
            CurrZZ240         =  0,
            CurrZZ1440        =  0,
            CurrZZ10080       =  0;
//ind ZZ duomenys
int         dp =  12;
int         dv =  5;            
int         bs =  3;         
//-----------------------------------------------------------------------------
//Procentas, kuriuo ilgasis spindulys turi buti ilgesnis uz sekanti trumpaji
//-----------------------------------------------------------------------------
extern double    RayDiffPercent     = 61.8; 
//-----------------------------------------------------------------------------
//Baru skaicius linijos brezimui i prieki
//-----------------------------------------------------------------------------
extern int       LineBarsUp         = 30;      
//********************************************************************************
//| expert initialization function                                   |
//********************************************************************************
int init()
  {
//----


}
//----

//******************************************************************************
//| expert deinitialization function                                 |
//******************************************************************************
int deinit()
  {
//----
   
//----
   return(0);
  }
//****************************************************************************
//| expert start function                                            |
//****************************************************************************
int start()
{
	//----
	int    i, ii, iii;
	//int k; 
	//int ke1=0,ke5=0,ke15=0,ke30=0,ke60=0, ke240=0,ke1440=0,ke10080=0;
   double zz;
   
	for(tf=0; tf<7; tf++)
    {
		if(tf == 0 && tf_M1)
        {
            Print("---------------------------------------------------M1_tf=",TimeFrame[tf],"----------------------------------------");
            int mn1 = MagicNumber + TimeFrame[tf];
            //---------------------------
            //NewTick
            //---------------------------
            


            //---------------------------
            //NewBar M1
            //---------------------------
            CurrTime1 = iTime(NULL,TimeFrame[tf],1);
            if (CurrTime1!=PrevTime1)
            {
               Print("M1_newTime=",TimeToStr(CurrTime1), "*******Nauja bara radom*********"); 
               
               //--------------------------------------
               // HL kanalo brezimas ir jo pramusimas
               //--------------------------------------          
               if(!Ch_isDraw)
               {
                  Ch_H=High[iHighest(NULL,TimeFrame[tf],MODE_HIGH,k,0)];   
                  Ch_L=Low[iLowest(NULL,TimeFrame[tf],MODE_LOW,k,0)];   
                  Ch=Ch_H-Ch_L;
                  if(Ch<Ch_max_M1*Point)
                  {
                     StartTime=iTime(NULL,TimeFrame[tf],minBars_M1);
                     EndTime=iTime(NULL,TimeFrame[tf],0);
                     string nameUP_M1="M1_UP_"+TimeToStr(StartTime, TIME_DATE|TIME_MINUTES)+"_"+TimeToStr(EndTime, TIME_DATE|TIME_MINUTES);
                     string nameDN_M1="M1_DN"+TimeToStr(StartTime, TIME_DATE|TIME_MINUTES)+"_"+TimeToStr(EndTime, TIME_DATE|TIME_MINUTES);
                     
                     ObjectCreate(nameUP_M1, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameUP_M1, OBJPROP_TIME1 , StartTime);
							ObjectSet   (nameUP_M1, OBJPROP_PRICE1,Ch_H);
							ObjectSet   (nameUP_M1, OBJPROP_TIME2 , EndTime);
							ObjectSet   (nameUP_M1, OBJPROP_PRICE2,Ch_H);
							ObjectSet   (nameUP_M1, OBJPROP_COLOR , c_M1);
							ObjectSet   (nameUP_M1, OBJPROP_RAY   , false);
							ObjectSet   (nameUP_M1, OBJPROP_STYLE , 1);
							ObjectSet   (nameUP_M1, OBJPROP_WIDTH , width_M1);
							
							ObjectCreate(nameDN_M1, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameDN_M1, OBJPROP_TIME1 , StartTime);
							ObjectSet   (nameDN_M1, OBJPROP_PRICE1,Ch_L);
							ObjectSet   (nameDN_M1, OBJPROP_TIME2 , EndTime);
							ObjectSet   (nameDN_M1, OBJPROP_PRICE2,Ch_L);
							ObjectSet   (nameDN_M1, OBJPROP_COLOR , c_M1);
							ObjectSet   (nameDN_M1, OBJPROP_RAY   , false);
							ObjectSet   (nameDN_M1, OBJPROP_STYLE , 1);
							ObjectSet   (nameDN_M1, OBJPROP_WIDTH , width_M1);
							
							string pre_nameUP_M1=nameUP_M1;
							string pre_nameDN_M1=nameDN_M1;
							k++;
                  }
               }
               else
               {
                  Ch_H=High[Highest(NULL,TimeFrame[tf],MODE_HIGH,k,0)];   
                  Ch_L=Low[Lowest(NULL,TimeFrame[tf],MODE_LOW,k,0)];   
                  Ch=Ch_H-Ch_L;
                  if(Ch<Ch_max_M1*Point)
                  {
                     StartTime=iTime(NULL,TimeFrame[tf],minBars_M1);
                     EndTime=iTime(NULL,TimeFrame[tf],0);
                     nameUP_M1="M1_UP_"+TimeToStr(StartTime, TIME_DATE|TIME_MINUTES)+"_"+TimeToStr(EndTime, TIME_DATE|TIME_MINUTES);
                     nameDN_M1="M1_DN"+TimeToStr(StartTime, TIME_DATE|TIME_MINUTES)+"_"+TimeToStr(EndTime, TIME_DATE|TIME_MINUTES);
                     
                     ObjectCreate(nameUP_M1, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameUP_M1, OBJPROP_TIME1 , StartTime);
							ObjectSet   (nameUP_M1, OBJPROP_PRICE1,Ch_H);
							ObjectSet   (nameUP_M1, OBJPROP_TIME2 , EndTime);
							ObjectSet   (nameUP_M1, OBJPROP_PRICE2,Ch_H);
							ObjectSet   (nameUP_M1, OBJPROP_COLOR , c_M1);
							ObjectSet   (nameUP_M1, OBJPROP_RAY   , false);
							ObjectSet   (nameUP_M1, OBJPROP_STYLE , 1);
							ObjectSet   (nameUP_M1, OBJPROP_WIDTH , width_M1);
							
							ObjectCreate(nameDN_M1, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameDN_M1, OBJPROP_TIME1 , StartTime);
							ObjectSet   (nameDN_M1, OBJPROP_PRICE1,Ch_L);
							ObjectSet   (nameDN_M1, OBJPROP_TIME2 , EndTime);
							ObjectSet   (nameDN_M1, OBJPROP_PRICE2,Ch_L);
							ObjectSet   (nameDN_M1, OBJPROP_COLOR , c_M1);
							ObjectSet   (nameDN_M1, OBJPROP_RAY   , false);
							ObjectSet   (nameDN_M1, OBJPROP_STYLE , 1);
							ObjectSet   (nameDN_M1, OBJPROP_WIDTH , width_M1);
							
							pre_nameUP_M1=nameUP_M1;
							pre_nameDN_M1=nameDN_M1;
							k++;
                  }
                  else
                  {
                    k=0;
                  }
               }
               //---------------------------
               //NewZigZag  M1
               //---------------------------
               int n=iBars(NULL, TimeFrame[tf]); 	                                       	 //esamu baru skaicius ekrane
               int k=0;				                                                       	    //rastu ekstremumu skaicius
               for (i=1; i<n; i++) 
                { 
            	    zz=iCustom(NULL, TimeFrame[tf], "ZigZag", dp, dv, bs, 0, i);
                    if (zz!=0) 
                    {                	
                	    k++;
                        if (k==2)			                                          	     //jei rasti du ekstremumai 
                        {
                           CurrZZ1 = zz;
                           break;
                        }
                    }															           //end (zz1!=0)
                }             																	              //end for(i=1; i<k; i++) 
				if(CurrZZ1!=PrevZZ1)
				{
					Print("M1_newZigZag=",CurrZZ1, "-*-*-*-*-*-Nauja ZigZag radom-*-*-*-*-*-*"); 
					//---------------------------
					//atsiradus naujam zz ekstremumui 
					//renkami duomenys i masyvus ir 
					//breziamos zz kanalo linijos
					//---------------------------
					//---------------------------------------------------
					// Masyvai
					//---------------------------------------------------
					double      p1[500];                                                             //kainu
					double      p1_diff[499];                                                        //kainu skirtumu
					double      p1_diff_Abs[499];                                                    //absoliuciu kainu skirtumu
					datetime    t1[500];                                                             //kainu laiko
					double      b1[500];                                                             //kainu barai				
					datetime    startTime1;                                                    //Laikas, nuo kurio prasides duomenu surinkimas
					int         StartBar1;                                                     //Baro Nr., nuo kurio prasides duomenu surinkimas
					//----------------------------------------
					//Surandam duomenu rinkimo pradzios laika
					//----------------------------------------
					n=iBars(NULL, TimeFrame[tf+2]);                                            //per du vyresnio TF baru skaicius
					k=0;
					for (i=1; i<n; i++) 
					{
						zz=iCustom(NULL, TimeFrame[tf+2], "ZigZag", dp, dv, bs, 0, i);
						if (zz!=0) 
						{
							k++;
							if (k==3) 
							{ 
								startTime1=iTime(NULL,TimeFrame[tf+2],i);                           //Laikas per du vyresnio TF nuo kurio prasides skaiciavimai
								Print("Skaiciavimo pradzios ieskosime +2 vyresniame TF   +++++++-M",TimeFrame[tf+2],"-+++++++");
								StartBar1=iBarShift(NULL,TimeFrame[tf],startTime1);                 //Baro Nr.esamo TF (M1)nuo kurio prasides skaiciavimai
								Print("Rasta skaiciavimo pradzia nuo   ",TimeToStr(startTime1, TIME_DATE|TIME_MINUTES));
								break;
							}
						}    
					}
					//------------------------------------------
					ii=0;
					for (i=1; i<StartBar1+2; i++) 
					{
						zz=iCustom(NULL,TimeFrame[tf],"ZigZag", dp, dv, bs,0,i);      
						if(zz!=0 /*&& zz!=EMPTY_VALUE*/)  
						{
							p1[ii]=zz;                                                              //zz ekstremumu kainu masyvo elementas su nenuline reiksme                                    
							t1[ii]=iTime(NULL, TimeFrame[tf], i);                                   //surasto baro laiko masyvo elementas su nenuline zz reiksme
							b1[ii]=i;                                                               //surastas baru masyvo elementas su nenuline zz reiksme            
							ii++;
						} 																    // end if(zz!=0 /*&& zz!=EMPTY_VALUE*/)
					} 																       //end for (i=1; i<StartBar; i++) 
					for(iii=0; iii<ii-1; iii++)
					{
						p1_diff[iii]=(p1[iii]-p1[iii+1])/Point;                                 //zz gretimu ekstremumu kainu skirtumo masyvo elementas 
						p1_diff_Abs[iii]=MathAbs(p1_diff[iii]);                                 //zz gretimu ekstremumu kainu absoliutaus skirtumo masyvo elementas
					} 																      //end for(iii=0; iii<ii-1; iii++)																					      
					ArrayResize(p1,ii);                                                        	//kainu
					ArrayResize(p1_diff,iii);                                                  	//kainu skirtumu
					ArrayResize(p1_diff_Abs,iii);                                              	//absoliuciu kainu skirtumu             
					ArrayResize(t1, ii);                                                       	//kainu laiko
					ArrayResize(b1, ii);                                                       	//kainu barai     
					Print("Elementu skaicius      ii=",ii,"     iii=",iii);
					//----------------------------------------
					//TL brezimas. ZZ spinduliai mazejantys
					//----------------------------------------
					if( //	p_diff[3]>0 &&                                                     //Jei 
						p1_diff_Abs[3]>p1_diff_Abs[2]*100/RayDiffPercent &&                  //
						p1_diff_Abs[2]*1.15>p1_diff_Abs[1] && 
						p1_diff_Abs[1]*1.15>p1_diff_Abs[0])
					{
						CurrLineTime1=iTime(NULL, TimeFrame[tf],0);
						if(CurrLineTime1>PrevLineTime1)
						{                               
							datetime tStartLine1=t1[3];                                                    //Linijos pradzios laikas
							double pStartLine1=p1[3];                                                      //Linijos pradzios kaina
							datetime tEndLine1=iTime(NULL,TimeFrame[tf],0)+LineBarsUp*TimeFrame[tf]*60;                       //Linijos pabaigos laikas
							double pEndLine1=EquationDirect(tStartLine1, pStartLine1, t1[1] , p1[1], tEndLine1); //Linijos pabaigos kaina                   
					      string nameM1_1="LineM1_1"+TimeToStr(tStartLine1,TIME_DATE|TIME_MINUTES);
					      
							ObjectCreate(nameM1_1, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameM1_1, OBJPROP_TIME1 , tStartLine1);
							ObjectSet   (nameM1_1, OBJPROP_PRICE1,pStartLine1);
							ObjectSet   (nameM1_1, OBJPROP_TIME2 , tEndLine1);
							ObjectSet   (nameM1_1, OBJPROP_PRICE2,pEndLine1);
							ObjectSet   (nameM1_1, OBJPROP_COLOR , c_M1);
							ObjectSet   (nameM1_1, OBJPROP_RAY   , false);
							ObjectSet   (nameM1_1, OBJPROP_STYLE , 1);
							ObjectSet   (nameM1_1, OBJPROP_WIDTH , width_M1);
							
							datetime tStartLine2=t1[2];
							double pStartLine2=p1[2];
							double pEndLine2=EquationDirect(tStartLine2,pStartLine2, t1[0], p1[0], tEndLine1);               //???????????
                     string nameM1_2="LineM1_2"+TimeToStr(tStartLine2,TIME_DATE|TIME_MINUTES);
                     
							ObjectCreate(nameM1_2, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameM1_2, OBJPROP_TIME1 , tStartLine2);
							ObjectSet   (nameM1_2, OBJPROP_PRICE1, pStartLine2);
							ObjectSet   (nameM1_2, OBJPROP_TIME2 , tEndLine1);
							ObjectSet   (nameM1_2, OBJPROP_PRICE2, pEndLine2);
							ObjectSet   (nameM1_2, OBJPROP_COLOR , c_M1);
							ObjectSet   (nameM1_2, OBJPROP_RAY   , false);
							ObjectSet   (nameM1_2, OBJPROP_STYLE , 1);
							ObjectSet   (nameM1_2, OBJPROP_WIDTH , width_M1);
                  
							PrevLineTime1=tEndLine1;
						}	
					}																	//end if(.....p_diff_Abs[3]>p_diff_Abs[2]*100/RayDiffPercent && ...)
					PrevZZ1=CurrZZ1;
				} 																		//end if(Curr_zz1!=Prev_zz1)
				PrevTime1 = CurrTime1;
			}																	// end if (CurrTime1!=PrevTime1)
		}																		//end if(tf == 0)
		if(tf == 1 && tf_M5)
	   {
            Print("---------------------------------------------------M5_tf=",TimeFrame[tf],"----------------------------------------");
            int mn5 = MagicNumber + TimeFrame[tf];
            //---------------------------
            //NewTick
            //---------------------------
            


            //---------------------------
            //NewBar M5
            //---------------------------
            CurrTime5 = iTime(NULL,TimeFrame[tf],1);
            if (CurrTime5!=PrevTime5)
            {
               Print("M5_newTime=",TimeToStr(CurrTime5), "*******Nauja bara radom*********");    
               
                //--------------------------------------
               // HL kanalo brezimas ir jo pramusimas
               //--------------------------------------          
               if(!Ch_isDraw)
               {
                  Ch_H=High[iHighest(NULL,TimeFrame[tf],MODE_HIGH,k,0)];   
                  Ch_L=Low[iLowest(NULL,TimeFrame[tf],MODE_LOW,k,0)];   
                  Ch=Ch_H-Ch_L;
                  if(Ch<Ch_max_M5*Point)
                  {
                     StartTime=iTime(NULL,TimeFrame[tf],minBars_M5);
                     EndTime=iTime(NULL,TimeFrame[tf],0);
                     string nameUP_M5="M5_UP_"+TimeToStr(StartTime, TIME_DATE|TIME_MINUTES)+"_"+TimeToStr(EndTime, TIME_DATE|TIME_MINUTES);
                     string nameDN_M5="M5_DN"+TimeToStr(StartTime, TIME_DATE|TIME_MINUTES)+"_"+TimeToStr(EndTime, TIME_DATE|TIME_MINUTES);
                     
                     ObjectCreate(nameUP_M5, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameUP_M5, OBJPROP_TIME1 , StartTime);
							ObjectSet   (nameUP_M5, OBJPROP_PRICE1,Ch_H);
							ObjectSet   (nameUP_M5, OBJPROP_TIME2 , EndTime);
							ObjectSet   (nameUP_M5, OBJPROP_PRICE2,Ch_H);
							ObjectSet   (nameUP_M5, OBJPROP_COLOR , c_M5);
							ObjectSet   (nameUP_M5, OBJPROP_RAY   , false);
							ObjectSet   (nameUP_M5, OBJPROP_STYLE , 1);
							ObjectSet   (nameUP_M5, OBJPROP_WIDTH , width_M5);
							
							ObjectCreate(nameDN_M5, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameDN_M5, OBJPROP_TIME1 , StartTime);
							ObjectSet   (nameDN_M5, OBJPROP_PRICE1,Ch_L);
							ObjectSet   (nameDN_M5, OBJPROP_TIME2 , EndTime);
							ObjectSet   (nameDN_M5, OBJPROP_PRICE2,Ch_L);
							ObjectSet   (nameDN_M5, OBJPROP_COLOR , c_M5);
							ObjectSet   (nameDN_M5, OBJPROP_RAY   , false);
							ObjectSet   (nameDN_M5, OBJPROP_STYLE , 1);
							ObjectSet   (nameDN_M5, OBJPROP_WIDTH , width_M5);
							
							string pre_nameUP_M5=nameUP_M5;
							string pre_nameDN_M5=nameDN_M5;
							k++;
                  }
               }
               else
               {
                  Ch_H=High[Highest(NULL,TimeFrame[tf],MODE_HIGH,k,0)];   
                  Ch_L=Low[Lowest(NULL,TimeFrame[tf],MODE_LOW,k,0)];   
                  Ch=Ch_H-Ch_L;
                  if(Ch<Ch_max_M5*Point)
                  {
                     
                     ObjectDelete("pre_nameUP_M5");
                     ObjectDelete("pre_nameDN_M5");
                     
                     StartTime=iTime(NULL,TimeFrame[tf],minBars_M5);
                     EndTime=iTime(NULL,TimeFrame[tf],0);
                     nameUP_M5="M5_UP_"+TimeToStr(StartTime, TIME_DATE|TIME_MINUTES)+"_"+TimeToStr(EndTime, TIME_DATE|TIME_MINUTES);
                     nameDN_M5="M5_DN"+TimeToStr(StartTime, TIME_DATE|TIME_MINUTES)+"_"+TimeToStr(EndTime, TIME_DATE|TIME_MINUTES);
                     
                     ObjectCreate(nameUP_M5, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameUP_M5, OBJPROP_TIME1 , StartTime);
							ObjectSet   (nameUP_M5, OBJPROP_PRICE1,Ch_H);
							ObjectSet   (nameUP_M5, OBJPROP_TIME2 , EndTime);
							ObjectSet   (nameUP_M5, OBJPROP_PRICE2,Ch_H);
							ObjectSet   (nameUP_M5, OBJPROP_COLOR , c_M5);
							ObjectSet   (nameUP_M5, OBJPROP_RAY   , false);
							ObjectSet   (nameUP_M5, OBJPROP_STYLE , 1);
							ObjectSet   (nameUP_M5, OBJPROP_WIDTH , width_M5);
							
							ObjectCreate(nameDN_M5, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameDN_M5, OBJPROP_TIME1 , StartTime);
							ObjectSet   (nameDN_M5, OBJPROP_PRICE1,Ch_L);
							ObjectSet   (nameDN_M5, OBJPROP_TIME2 , EndTime);
							ObjectSet   (nameDN_M5, OBJPROP_PRICE2,Ch_L);
							ObjectSet   (nameDN_M5, OBJPROP_COLOR , c_M5);
							ObjectSet   (nameDN_M5, OBJPROP_RAY   , false);
							ObjectSet   (nameDN_M5, OBJPROP_STYLE , 1);
							ObjectSet   (nameDN_M5, OBJPROP_WIDTH , width_M5);
							
							pre_nameUP_M5=nameUP_M5;
							pre_nameDN_M5=nameDN_M5;
							k++;
                  }
                  else
                  {
                    k=0;
                  }
               }          
               //---------------------------
               //NewZigZag  M5
               //---------------------------
               n=iBars(NULL, TimeFrame[tf]); 	                                       	 //esamu baru skaicius ekrane
               k=0;				                                                       	    //rastu ekstremumu skaicius
               for (i=1; i<n; i++) 
                { 
            	    zz=iCustom(NULL, TimeFrame[tf], "ZigZag", dp, dv, bs, 0, i);
                    if (zz!=0) 
                    {                	
                	    k++;
                        if (k==2)			                                          	     //jei rasti du ekstremumai 
                        {
                           CurrZZ5 = zz;
                           break;
                        }
                    }															           //end (zz1!=0)
                }             																	              //end for(i=1; i<k; i++) 
				if(CurrZZ5!=PrevZZ5)
				{
					Print("M5_newZigZag=",CurrZZ5, "-*-*-*-*-*-Nauja ZigZag radom-*-*-*-*-*-*"); 
					//---------------------------
					//atsiradus naujam zz ekstremumui 
					//renkami duomenys i masyvus ir 
					//breziamos zz kanalo linijos
					//---------------------------
					//---------------------------------------------------
					// Masyvai
					//---------------------------------------------------
					double      p5[500];                                                             //kainu
					double      p5_diff[499];                                                        //kainu skirtumu
					double      p5_diff_Abs[499];                                                    //absoliuciu kainu skirtumu
					datetime    t5[500];                                                             //kainu laiko
					double      b5[500];                                                             //kainu barai				
					datetime    startTime5;                                                    //Laikas, nuo kurio prasides duomenu surinkimas
					int         StartBar5;                                                     //Baro Nr., nuo kurio prasides duomenu surinkimas
					//----------------------------------------
					//Surandam duomenu rinkimo pradzios laika
					//----------------------------------------
					n=iBars(NULL, TimeFrame[tf+2]);                                            //per du vyresnio TF baru skaicius
					k=0;
					for (i=1; i<n; i++) 
					{
						zz=iCustom(NULL, TimeFrame[tf+2], "ZigZag", dp, dv, bs, 0, i);
						if (zz!=0) 
						{
							k++;
							if (k==3) 
							{ 
								startTime5=iTime(NULL,TimeFrame[tf+2],i);                           //Laikas per du vyresnio TF nuo kurio prasides skaiciavimai
								Print("Skaiciavimo pradzios ieskosime +2 vyresniame TF   +++++++-M",TimeFrame[tf+2],"-+++++++");
								StartBar5=iBarShift(NULL,TimeFrame[tf],startTime5);                 //Baro Nr.esamo TF (M1)nuo kurio prasides skaiciavimai
								Print("Rasta skaiciavimo pradzia nuo   ",TimeToStr(startTime5, TIME_DATE|TIME_MINUTES));
								break;
							}
						}    
					}
					//------------------------------------------
					ii=0;
					for (i=1; i<StartBar5+2; i++) 
					{
						zz=iCustom(NULL,TimeFrame[tf],"ZigZag", dp, dv, bs,0,i);      
						if(zz!=0 /*&& zz!=EMPTY_VALUE*/)  
						{
							p5[ii]=zz;                                                              //zz ekstremumu kainu masyvo elementas su nenuline reiksme                                    
							t5[ii]=iTime(NULL, TimeFrame[tf], i);                                   //surasto baro laiko masyvo elementas su nenuline zz reiksme
							b5[ii]=i;                                                               //surastas baru masyvo elementas su nenuline zz reiksme            
							ii++;
						} 																    // end if(zz!=0 /*&& zz!=EMPTY_VALUE*/)
					} 																       //end for (i=1; i<StartBar; i++) 
					for(iii=0; iii<ii-1; iii++)
					{
						p5_diff[iii]=(p5[iii]-p5[iii+1])/Point;                                 //zz gretimu ekstremumu kainu skirtumo masyvo elementas 
						p5_diff_Abs[iii]=MathAbs(p5_diff[iii]);                                 //zz gretimu ekstremumu kainu absoliutaus skirtumo masyvo elementas
					} 																      //end for(iii=0; iii<ii-1; iii++)																					      
					ArrayResize(p5,ii);                                                        	//kainu
					ArrayResize(p5_diff,iii);                                                  	//kainu skirtumu
					ArrayResize(p5_diff_Abs,iii);                                              	//absoliuciu kainu skirtumu             
					ArrayResize(t5, ii);                                                       	//kainu laiko
					ArrayResize(b5, ii);                                                       	//kainu barai     
					Print("Elementu skaicius      ii=",ii,"     iii=",iii);
					//----------------------------------------
					//TL brezimas. ZZ spinduliai mazejantys
					//----------------------------------------
					if( //	p_diff[3]>0 &&                                                     //Jei 
						p5_diff_Abs[4]>p5_diff_Abs[3]*100/RayDiffPercent &&                  //
						p5_diff_Abs[3]*1.15>p5_diff_Abs[2] && 
						p5_diff_Abs[2]*1.15>p5_diff_Abs[1])
					{
						CurrLineTime5=iTime(NULL, TimeFrame[tf],0);
						if(CurrLineTime5>PrevLineTime5)
						{                              
							tStartLine1=t5[4];                                                    //Linijos pradzios laikas
							pStartLine1=p5[4];                                                      //Linijos pradzios kaina
							tEndLine1=iTime(NULL,TimeFrame[tf],0)+LineBarsUp*TimeFrame[tf]*60;                       //Linijos pabaigos laikas
							pEndLine1=EquationDirect(tStartLine1, pStartLine1, t5[2] , p5[2], tEndLine1); //Linijos pabaigos kaina                   
					      string nameM5_1="LineM5_1"+TimeToStr(tStartLine1,TIME_DATE|TIME_MINUTES);
					      
							ObjectCreate(nameM5_1, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameM5_1, OBJPROP_TIME1 , tStartLine1);
							ObjectSet   (nameM5_1, OBJPROP_PRICE1,pStartLine1);
							ObjectSet   (nameM5_1, OBJPROP_TIME2 , tEndLine1);
							ObjectSet   (nameM5_1, OBJPROP_PRICE2,pEndLine1);
							ObjectSet   (nameM5_1, OBJPROP_COLOR , c_M5);
							ObjectSet   (nameM5_1, OBJPROP_RAY   , false);
							ObjectSet   (nameM5_1, OBJPROP_STYLE , 0);
							ObjectSet   (nameM5_1, OBJPROP_WIDTH , width_M5);
							
							tStartLine2=t5[3];
							pStartLine2=p5[3];
							pEndLine2=EquationDirect(tStartLine2,pStartLine2, t5[1], p5[1], tEndLine1);               //???????????
                     string nameM5_2="LineM5_2"+TimeToStr(tStartLine2,TIME_DATE|TIME_MINUTES);
                     
							ObjectCreate(nameM5_2, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameM5_2, OBJPROP_TIME1 , tStartLine2);
							ObjectSet   (nameM5_2, OBJPROP_PRICE1, pStartLine2);
							ObjectSet   (nameM5_2, OBJPROP_TIME2 , tEndLine1);
							ObjectSet   (nameM5_2, OBJPROP_PRICE2, pEndLine2);
							ObjectSet   (nameM5_2, OBJPROP_COLOR , c_M5);
							ObjectSet   (nameM5_2, OBJPROP_RAY   , false);
							ObjectSet   (nameM5_2, OBJPROP_STYLE , 0);
							ObjectSet   (nameM5_2, OBJPROP_WIDTH , width_M5);
                  
							PrevLineTime5=tEndLine1;
						}	
					}																	//end if(.....p_diff_Abs[3]>p_diff_Abs[2]*100/RayDiffPercent && ...)
					PrevZZ5=CurrZZ5;
				} 																		//end if(Curr_zz1!=Prev_zz1)
				PrevTime5 = CurrTime5;
			}																	// end if (CurrTime1!=PrevTime1)
		}																				              //end for(i=1; i<k; i++)					
		if(tf == 2 && tf_M15)
		{
            Print("---------------------------------------------------M15_tf=",TimeFrame[tf],"----------------------------------------");
            int mn15 = MagicNumber + TimeFrame[tf];
            //---------------------------
            //NewTick
            //---------------------------
            


            //---------------------------
            //NewBar M15
            //---------------------------
            CurrTime15 = iTime(NULL,TimeFrame[tf],1);
            if (CurrTime15!=PrevTime15)
            {
               Print("M15_newTime=",TimeToStr(CurrTime15), "*******Nauja bara radom*********");              
               //---------------------------
               //NewZigZag  M15
               //---------------------------
               n=iBars(NULL, TimeFrame[tf]); 	                                       	 //esamu baru skaicius ekrane
               k=0;				                                                       	    //rastu ekstremumu skaicius
               for (i=1; i<n; i++) 
                { 
            	    zz=iCustom(NULL, TimeFrame[tf], "ZigZag", dp, dv, bs, 0, i);
                    if (zz!=0) 
                    {                	
                	    k++;
                        if (k==2)			                                          	     //jei rasti du ekstremumai 
                        {
                           CurrZZ15 = zz;
                           break;
                        }
                    }															           //end (zz1!=0)
                }             																	              //end for(i=1; i<k; i++) 
				if(CurrZZ15!=PrevZZ15)
				{
					Print("M15_newZigZag=",CurrZZ15, "-*-*-*-*-*-Nauja ZigZag radom-*-*-*-*-*-*"); 
					//---------------------------
					//atsiradus naujam zz ekstremumui 
					//renkami duomenys i masyvus ir 
					//breziamos zz kanalo linijos
					//---------------------------
					//---------------------------------------------------
					// Masyvai
					//---------------------------------------------------
					double      p15[500];                                                             //kainu
					double      p15_diff[499];                                                        //kainu skirtumu
					double      p15_diff_Abs[499];                                                    //absoliuciu kainu skirtumu
					datetime    t15[500];                                                             //kainu laiko
					double      b15[500];                                                             //kainu barai				
					datetime    startTime15;                                                    //Laikas, nuo kurio prasides duomenu surinkimas
					int         StartBar15;                                                     //Baro Nr., nuo kurio prasides duomenu surinkimas
					//----------------------------------------
					//Surandam duomenu rinkimo pradzios laika
					//----------------------------------------
					n=iBars(NULL, TimeFrame[tf+2]);                                            //per du vyresnio TF baru skaicius
					k=0;
					for (i=1; i<n; i++) 
					{
						zz=iCustom(NULL, TimeFrame[tf+2], "ZigZag", dp, dv, bs, 0, i);
						if (zz!=0) 
						{
							k++;
							if (k==3) 
							{ 
								startTime15=iTime(NULL,TimeFrame[tf+2],i);                           //Laikas per du vyresnio TF nuo kurio prasides skaiciavimai
								Print("Skaiciavimo pradzios ieskosime +2 vyresniame TF   +++++++-M",TimeFrame[tf+2],"-+++++++");
								StartBar15=iBarShift(NULL,TimeFrame[tf],startTime15);                 //Baro Nr.esamo TF (M1)nuo kurio prasides skaiciavimai
								Print("Rasta skaiciavimo pradzia nuo   ",TimeToStr(startTime15, TIME_DATE|TIME_MINUTES));
								break;
							}
						}    
					}
					//------------------------------------------
					ii=0;
					for (i=1; i<StartBar15+2; i++) 
					{
						zz=iCustom(NULL,TimeFrame[tf],"ZigZag", dp, dv, bs,0,i);      
						if(zz!=0 /*&& zz!=EMPTY_VALUE*/)  
						{
							p15[ii]=zz;                                                              //zz ekstremumu kainu masyvo elementas su nenuline reiksme                                    
							t15[ii]=iTime(NULL, TimeFrame[tf], i);                                   //surasto baro laiko masyvo elementas su nenuline zz reiksme
							b15[ii]=i;                                                               //surastas baru masyvo elementas su nenuline zz reiksme            
							ii++;
						} 																    // end if(zz!=0 /*&& zz!=EMPTY_VALUE*/)
					} 																       //end for (i=1; i<StartBar; i++) 
					for(iii=0; iii<ii-1; iii++)
					{
						p15_diff[iii]=(p15[iii]-p15[iii+1])/Point;                                 //zz gretimu ekstremumu kainu skirtumo masyvo elementas 
						p15_diff_Abs[iii]=MathAbs(p15_diff[iii]);                                 //zz gretimu ekstremumu kainu absoliutaus skirtumo masyvo elementas
					} 																      //end for(iii=0; iii<ii-1; iii++)																					      
					ArrayResize(p15,ii);                                                        	//kainu
					ArrayResize(p15_diff,iii);                                                  	//kainu skirtumu
					ArrayResize(p15_diff_Abs,iii);                                              	//absoliuciu kainu skirtumu             
					ArrayResize(t15, ii);                                                       	//kainu laiko
					ArrayResize(b15, ii);                                                       	//kainu barai     
					Print("Elementu skaicius      ii=",ii,"     iii=",iii);
					//----------------------------------------
					//TL brezimas. ZZ spinduliai mazejantys
					//----------------------------------------
					if( //	p_diff[3]>0 &&                                                     //Jei 
						p15_diff_Abs[4]>p15_diff_Abs[3]*100/RayDiffPercent &&                  //
						p15_diff_Abs[3]*1.15>p15_diff_Abs[2] && 
						p15_diff_Abs[2]*1.15>p15_diff_Abs[1])
					{
						CurrLineTime15=iTime(NULL, TimeFrame[tf],0);
						if(CurrLineTime15>PrevLineTime15)
						{                               
							tStartLine1=t15[4];                                                    //Linijos pradzios laikas
							pStartLine1=p15[4];                                                      //Linijos pradzios kaina
							tEndLine1=iTime(NULL,TimeFrame[tf],0)+LineBarsUp*TimeFrame[tf]*60;                       //Linijos pabaigos laikas
							pEndLine1=EquationDirect(tStartLine1, pStartLine1, t15[2] , p15[2], tEndLine1); //Linijos pabaigos kaina                   
					      string nameM15_1="LineM15_1"+TimeToStr(tStartLine1,TIME_DATE|TIME_MINUTES);
					      
							ObjectCreate(nameM15_1, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameM15_1, OBJPROP_TIME1 , tStartLine1);
							ObjectSet   (nameM15_1, OBJPROP_PRICE1,pStartLine1);
							ObjectSet   (nameM15_1, OBJPROP_TIME2 , tEndLine1);
							ObjectSet   (nameM15_1, OBJPROP_PRICE2,pEndLine1);
							ObjectSet   (nameM15_1, OBJPROP_COLOR , c_M15);
							ObjectSet   (nameM15_1, OBJPROP_RAY   , false);
							ObjectSet   (nameM15_1, OBJPROP_STYLE , 0);
							ObjectSet   (nameM15_1, OBJPROP_WIDTH , width_M15);
							
							tStartLine2=t15[3];
							pStartLine2=p15[3];
							pEndLine2=EquationDirect(tStartLine2,pStartLine2, t15[1], p15[1], tEndLine1);               //???????????
                     string nameM15_2="LineM15_2"+TimeToStr(tStartLine2,TIME_DATE|TIME_MINUTES);
                     
							ObjectCreate(nameM15_2, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameM15_2, OBJPROP_TIME1 , tStartLine2);
							ObjectSet   (nameM15_2, OBJPROP_PRICE1, pStartLine2);
							ObjectSet   (nameM15_2, OBJPROP_TIME2 , tEndLine1);
							ObjectSet   (nameM15_2, OBJPROP_PRICE2, pEndLine2);
							ObjectSet   (nameM15_2, OBJPROP_COLOR , c_M15);
							ObjectSet   (nameM15_2, OBJPROP_RAY   , false);
							ObjectSet   (nameM15_2, OBJPROP_STYLE , 0);
							ObjectSet   (nameM15_2, OBJPROP_WIDTH , width_M15);
                  
							PrevLineTime15=tEndLine1;
						}	
					}																	//end if(.....p_diff_Abs[3]>p_diff_Abs[2]*100/RayDiffPercent && ...)
					PrevZZ15=CurrZZ15;
				} 																		//end if(Curr_zz1!=Prev_zz1)
				PrevTime15 = CurrTime15;
			}																	// end if (CurrTime1!=PrevTime1)
		}		
		if(tf == 3 && tf_M30)
		{
            Print("---------------------------------------------------M30_tf=",TimeFrame[tf],"----------------------------------------");
            int mn30 = MagicNumber + TimeFrame[tf];
            //---------------------------
            //NewTick
            //---------------------------
            


            //---------------------------
            //NewBar M30
            //---------------------------
            CurrTime30 = iTime(NULL,TimeFrame[tf],1);
            if (CurrTime30!=PrevTime30)
            {
               Print("M30_newTime=",TimeToStr(CurrTime30), "*******Nauja bara radom*********");              
               //---------------------------
               //NewZigZag  M30
               //---------------------------
               n=iBars(NULL, TimeFrame[tf]); 	                                       	 //esamu baru skaicius ekrane
               k=0;				                                                       	    //rastu ekstremumu skaicius
               for (i=1; i<n; i++) 
                { 
            	    zz=iCustom(NULL, TimeFrame[tf], "ZigZag", dp, dv, bs, 0, i);
                    if (zz!=0) 
                    {                	
                	    k++;
                        if (k==2)			                                          	     //jei rasti du ekstremumai 
                        {
                           CurrZZ30 = zz;
                           break;
                        }
                    }															           //end (zz1!=0)
                }             																	              //end for(i=1; i<k; i++) 
				if(CurrZZ30!=PrevZZ30)
				{
					Print("M30_newZigZag=",CurrZZ30, "-*-*-*-*-*-Nauja ZigZag radom-*-*-*-*-*-*"); 
					//---------------------------
					//atsiradus naujam zz ekstremumui 
					//renkami duomenys i masyvus ir 
					//breziamos zz kanalo linijos
					//---------------------------
					//---------------------------------------------------
					// Masyvai
					//---------------------------------------------------
					double      p30[500];                                                             //kainu
					double      p30_diff[499];                                                        //kainu skirtumu
					double      p30_diff_Abs[499];                                                    //absoliuciu kainu skirtumu
					datetime    t30[500];                                                             //kainu laiko
					double      b30[500];                                                             //kainu barai				
					datetime    startTime30;                                                    //Laikas, nuo kurio prasides duomenu surinkimas
					int         StartBar30;                                                     //Baro Nr., nuo kurio prasides duomenu surinkimas
					//----------------------------------------
					//Surandam duomenu rinkimo pradzios laika
					//----------------------------------------
					n=iBars(NULL, TimeFrame[tf+2]);                                            //per du vyresnio TF baru skaicius
					k=0;
					for (i=1; i<n; i++) 
					{
						zz=iCustom(NULL, TimeFrame[tf+2], "ZigZag", dp, dv, bs, 0, i);
						if (zz!=0) 
						{
							k++;
							if (k==3) 
							{ 
								startTime30=iTime(NULL,TimeFrame[tf+2],i);                           //Laikas per du vyresnio TF nuo kurio prasides skaiciavimai
								Print("Skaiciavimo pradzios ieskosime +2 vyresniame TF   +++++++-M",TimeFrame[tf+2],"-+++++++");
								StartBar30=iBarShift(NULL,TimeFrame[tf],startTime30);                 //Baro Nr.esamo TF (M1)nuo kurio prasides skaiciavimai
								Print("Rasta skaiciavimo pradzia nuo   ",TimeToStr(startTime30, TIME_DATE|TIME_MINUTES));
								break;
							}
						}    
					}
					//------------------------------------------
					ii=0;
					for (i=1; i<StartBar30+2; i++) 
					{
						zz=iCustom(NULL,TimeFrame[tf],"ZigZag", dp, dv, bs,0,i);      
						if(zz!=0 /*&& zz!=EMPTY_VALUE*/)  
						{
							p30[ii]=zz;                                                              //zz ekstremumu kainu masyvo elementas su nenuline reiksme                                    
							t30[ii]=iTime(NULL, TimeFrame[tf], i);                                   //surasto baro laiko masyvo elementas su nenuline zz reiksme
							b30[ii]=i;                                                               //surastas baru masyvo elementas su nenuline zz reiksme            
							ii++;
						} 																    // end if(zz!=0 /*&& zz!=EMPTY_VALUE*/)
					} 																       //end for (i=1; i<StartBar; i++) 
					for(iii=0; iii<ii-1; iii++)
					{
						p30_diff[iii]=(p30[iii]-p30[iii+1])/Point;                                 //zz gretimu ekstremumu kainu skirtumo masyvo elementas 
						p30_diff_Abs[iii]=MathAbs(p30_diff[iii]);                                 //zz gretimu ekstremumu kainu absoliutaus skirtumo masyvo elementas
					} 																      //end for(iii=0; iii<ii-1; iii++)																					      
					ArrayResize(p30,ii);                                                        	//kainu
					ArrayResize(p30_diff,iii);                                                  	//kainu skirtumu
					ArrayResize(p30_diff_Abs,iii);                                              	//absoliuciu kainu skirtumu             
					ArrayResize(t30, ii);                                                       	//kainu laiko
					ArrayResize(b30, ii);                                                       	//kainu barai     
					Print("Elementu skaicius      ii=",ii,"     iii=",iii);
					//----------------------------------------
					//TL brezimas. ZZ spinduliai mazejantys
					//----------------------------------------
					if( //	p_diff[3]>0 &&                                                     //Jei 
						p30_diff_Abs[4]>p30_diff_Abs[3]*100/RayDiffPercent &&                  //
						p30_diff_Abs[3]*1.15>p30_diff_Abs[2] && 
						p30_diff_Abs[2]*1.15>p30_diff_Abs[1])
					{
						CurrLineTime30=iTime(NULL, TimeFrame[tf],0);
						if(CurrLineTime30>PrevLineTime30)
						{                               
							tStartLine1=t30[4];                                                    //Linijos pradzios laikas
							pStartLine1=p30[4];                                                      //Linijos pradzios kaina
							tEndLine1=iTime(NULL,TimeFrame[tf],0)+LineBarsUp*TimeFrame[tf]*60;                       //Linijos pabaigos laikas
							pEndLine1=EquationDirect(tStartLine1, pStartLine1, t30[2] , p30[2], tEndLine1); //Linijos pabaigos kaina                   
					      string nameM30_1="LineM30_1"+TimeToStr(tStartLine1,TIME_DATE|TIME_MINUTES);
					      
							ObjectCreate(nameM30_1, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameM30_1, OBJPROP_TIME1 , tStartLine1);
							ObjectSet   (nameM30_1, OBJPROP_PRICE1,pStartLine1);
							ObjectSet   (nameM30_1, OBJPROP_TIME2 , tEndLine1);
							ObjectSet   (nameM30_1, OBJPROP_PRICE2,pEndLine1);
							ObjectSet   (nameM30_1, OBJPROP_COLOR , c_M30);
							ObjectSet   (nameM30_1, OBJPROP_RAY   , false);
							ObjectSet   (nameM30_1, OBJPROP_STYLE , 0);
							ObjectSet   (nameM30_1, OBJPROP_WIDTH , width_M30);
							
							tStartLine2=t30[3];
							pStartLine2=p30[3];
							pEndLine2=EquationDirect(tStartLine2,pStartLine2, t30[1], p30[1], tEndLine1);               //???????????
                     string nameM30_2="LineM30_2"+TimeToStr(tStartLine2,TIME_DATE|TIME_MINUTES);
                     
							ObjectCreate(nameM30_2, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameM30_2, OBJPROP_TIME1 , tStartLine2);
							ObjectSet   (nameM30_2, OBJPROP_PRICE1, pStartLine2);
							ObjectSet   (nameM30_2, OBJPROP_TIME2 , tEndLine1);
							ObjectSet   (nameM30_2, OBJPROP_PRICE2, pEndLine2);
							ObjectSet   (nameM30_2, OBJPROP_COLOR , c_M30);
							ObjectSet   (nameM30_2, OBJPROP_RAY   , false);
							ObjectSet   (nameM30_2, OBJPROP_STYLE , 0);
							ObjectSet   (nameM30_2, OBJPROP_WIDTH , width_M30);
                  
							PrevLineTime30=tEndLine1;
						}	
					}																	//end if(.....p_diff_Abs[3]>p_diff_Abs[2]*100/RayDiffPercent && ...)
					PrevZZ30=CurrZZ30;
				} 																		//end if(Curr_zz1!=Prev_zz1)
				PrevTime30 = CurrTime30;
			}																	// end if (CurrTime1!=PrevTime1)
		}		
		if(tf == 4 && tf_M60)
		{
            Print("---------------------------------------------------M60_tf=",TimeFrame[tf],"----------------------------------------");
            int mn60 = MagicNumber + TimeFrame[tf];
            //---------------------------
            //NewTick
            //---------------------------
            


            //---------------------------
            //NewBar M60
            //---------------------------
            CurrTime60 = iTime(NULL,TimeFrame[tf],1);
            if (CurrTime60!=PrevTime60)
            {
               Print("M60_newTime=",TimeToStr(CurrTime60), "*******Nauja bara radom*********");              
               //---------------------------
               //NewZigZag  M360
               //---------------------------
               n=iBars(NULL, TimeFrame[tf]); 	                                       	 //esamu baru skaicius ekrane
               k=0;				                                                       	    //rastu ekstremumu skaicius
               for (i=1; i<n; i++) 
                { 
            	    zz=iCustom(NULL, TimeFrame[tf], "ZigZag", dp, dv, bs, 0, i);
                    if (zz!=0) 
                    {                	
                	    k++;
                        if (k==2)			                                          	     //jei rasti du ekstremumai 
                        {
                           CurrZZ60 = zz;
                           break;
                        }
                    }															           //end (zz1!=0)
                }             																	              //end for(i=1; i<k; i++) 
				if(CurrZZ60!=PrevZZ60)
				{
					Print("M60_newZigZag=",CurrZZ60, "-*-*-*-*-*-Nauja ZigZag radom-*-*-*-*-*-*"); 
					//---------------------------
					//atsiradus naujam zz ekstremumui 
					//renkami duomenys i masyvus ir 
					//breziamos zz kanalo linijos
					//---------------------------
					//---------------------------------------------------
					// Masyvai
					//---------------------------------------------------
					double      p60[500];                                                             //kainu
					double      p60_diff[499];                                                        //kainu skirtumu
					double      p60_diff_Abs[499];                                                    //absoliuciu kainu skirtumu
					datetime    t60[500];                                                             //kainu laiko
					double      b60[500];                                                             //kainu barai				
					datetime    startTime60;                                                    //Laikas, nuo kurio prasides duomenu surinkimas
					int         StartBar60;                                                     //Baro Nr., nuo kurio prasides duomenu surinkimas
					//----------------------------------------
					//Surandam duomenu rinkimo pradzios laika
					//----------------------------------------
					n=iBars(NULL, TimeFrame[tf+2]);                                            //per du vyresnio TF baru skaicius
					k=0;
					for (i=1; i<n; i++) 
					{
						zz=iCustom(NULL, TimeFrame[tf+2], "ZigZag", dp, dv, bs, 0, i);
						if (zz!=0) 
						{
							k++;
							if (k==3) 
							{ 
								startTime60=iTime(NULL,TimeFrame[tf+2],i);                           //Laikas per du vyresnio TF nuo kurio prasides skaiciavimai
								Print("Skaiciavimo pradzios ieskosime +2 vyresniame TF   +++++++-M",TimeFrame[tf+2],"-+++++++");
								StartBar60=iBarShift(NULL,TimeFrame[tf],startTime60);                 //Baro Nr.esamo TF (M1)nuo kurio prasides skaiciavimai
								Print("Rasta skaiciavimo pradzia nuo   ",TimeToStr(startTime60, TIME_DATE|TIME_MINUTES));
								break;
							}
						}    
					}
					//------------------------------------------
					ii=0;
					for (i=1; i<StartBar60+2; i++) 
					{
						zz=iCustom(NULL,TimeFrame[tf],"ZigZag", dp, dv, bs,0,i);      
						if(zz!=0 /*&& zz!=EMPTY_VALUE*/)  
						{
							p60[ii]=zz;                                                              //zz ekstremumu kainu masyvo elementas su nenuline reiksme                                    
							t60[ii]=iTime(NULL, TimeFrame[tf], i);                                   //surasto baro laiko masyvo elementas su nenuline zz reiksme
							b60[ii]=i;                                                               //surastas baru masyvo elementas su nenuline zz reiksme            
							ii++;
						} 																    // end if(zz!=0 /*&& zz!=EMPTY_VALUE*/)
					} 																       //end for (i=1; i<StartBar; i++) 
					for(iii=0; iii<ii-1; iii++)
					{
						p60_diff[iii]=(p60[iii]-p60[iii+1])/Point;                                 //zz gretimu ekstremumu kainu skirtumo masyvo elementas 
						p60_diff_Abs[iii]=MathAbs(p60_diff[iii]);                                 //zz gretimu ekstremumu kainu absoliutaus skirtumo masyvo elementas
					} 																      //end for(iii=0; iii<ii-1; iii++)																					      
					ArrayResize(p60,ii);                                                        	//kainu
					ArrayResize(p60_diff,iii);                                                  	//kainu skirtumu
					ArrayResize(p60_diff_Abs,iii);                                              	//absoliuciu kainu skirtumu             
					ArrayResize(t60, ii);                                                       	//kainu laiko
					ArrayResize(b60, ii);                                                       	//kainu barai     
					Print("Elementu skaicius      ii=",ii,"     iii=",iii);
					//----------------------------------------
					//TL brezimas. ZZ spinduliai mazejantys
					//----------------------------------------
					if( //	p_diff[3]>0 &&                                                     //Jei 
						p60_diff_Abs[4]>p60_diff_Abs[2]*100/RayDiffPercent &&                  //
						p60_diff_Abs[3]*1.15>p60_diff_Abs[2] && 
						p60_diff_Abs[2]*1.15>p60_diff_Abs[1])
					{
						CurrLineTime60=iTime(NULL, TimeFrame[tf],0);
						if(CurrLineTime60>PrevLineTime60)
						{                               
							tStartLine1=t60[4];                                          //Linijos pradzios laikas
							pStartLine1=p60[4];                                                      //Linijos pradzios kaina
							tEndLine1=iTime(NULL,TimeFrame[tf],0)+LineBarsUp*TimeFrame[tf]*60;                       //Linijos pabaigos laikas
							pEndLine1=EquationDirect(tStartLine1, pStartLine1, t60[2] , p60[2], tEndLine1); //Linijos pabaigos kaina                   
					      string nameM60_1="LineM60_1"+TimeToStr(tStartLine1,TIME_DATE|TIME_MINUTES);
					      
							ObjectCreate(nameM60_1, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameM60_1, OBJPROP_TIME1 , tStartLine1);
							ObjectSet   (nameM60_1, OBJPROP_PRICE1,pStartLine1);
							ObjectSet   (nameM60_1, OBJPROP_TIME2 , tEndLine1);
							ObjectSet   (nameM60_1, OBJPROP_PRICE2,pEndLine1);
							ObjectSet   (nameM60_1, OBJPROP_COLOR , c_M60);
							ObjectSet   (nameM60_1, OBJPROP_RAY   , false);
							ObjectSet   (nameM60_1, OBJPROP_STYLE , 0);
							ObjectSet   (nameM60_1, OBJPROP_WIDTH , width_M60);
							
							tStartLine2=t60[3];
							pStartLine2=p60[3];
							pEndLine2=EquationDirect(tStartLine2,pStartLine2, t60[1], p60[1], tEndLine1);               //???????????
                     string nameM60_2="LineM60_2"+TimeToStr(tStartLine2,TIME_DATE|TIME_MINUTES);
                     
							ObjectCreate(nameM60_2, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameM60_2, OBJPROP_TIME1 , tStartLine2);
							ObjectSet   (nameM60_2, OBJPROP_PRICE1, pStartLine2);
							ObjectSet   (nameM60_2, OBJPROP_TIME2 , tEndLine1);
							ObjectSet   (nameM60_2, OBJPROP_PRICE2, pEndLine2);
							ObjectSet   (nameM60_2, OBJPROP_COLOR , c_M60);
							ObjectSet   (nameM60_2, OBJPROP_RAY   , false);
							ObjectSet   (nameM60_2, OBJPROP_STYLE , 0);
							ObjectSet   (nameM60_2, OBJPROP_WIDTH , width_M60);
                  
							PrevLineTime60=tEndLine1;
						}	
					}																	//end if(.....p_diff_Abs[3]>p_diff_Abs[2]*100/RayDiffPercent && ...)
					PrevZZ60=CurrZZ60;
				} 																		//end if(Curr_zz1!=Prev_zz1)
				PrevTime60 = CurrTime60;
			}																	// end if (CurrTime1!=PrevTime1)
		}		
		if(tf == 5 && tf_M240)
{
            Print("---------------------------------------------------M240_tf=",TimeFrame[tf],"----------------------------------------");
            int mn240 = MagicNumber + TimeFrame[tf];
            //---------------------------
            //NewTick
            //---------------------------
            


            //---------------------------
            //NewBar M240
            //---------------------------
            CurrTime240 = iTime(NULL,TimeFrame[tf],1);
            if (CurrTime240!=PrevTime240)
            {
               Print("M240_newTime=",TimeToStr(CurrTime240), "*******Nauja bara radom*********");              
               //---------------------------
               //NewZigZag  M240
               //---------------------------
               n=iBars(NULL, TimeFrame[tf]); 	                                       	 //esamu baru skaicius ekrane
               k=0;				                                                       	    //rastu ekstremumu skaicius
               for (i=1; i<n; i++) 
                { 
            	    zz=iCustom(NULL, TimeFrame[tf], "ZigZag", dp, dv, bs, 0, i);
                    if (zz!=0) 
                    {                	
                	    k++;
                        if (k==2)			                                          	     //jei rasti du ekstremumai 
                        {
                           CurrZZ240 = zz;
                           break;
                        }
                    }															           //end (zz1!=0)
                }             																	              //end for(i=1; i<k; i++) 
				if(CurrZZ240!=PrevZZ240)
				{
					Print("M240_newZigZag=",CurrZZ240, "-*-*-*-*-*-Nauja ZigZag radom-*-*-*-*-*-*"); 
					//---------------------------
					//atsiradus naujam zz ekstremumui 
					//renkami duomenys i masyvus ir 
					//breziamos zz kanalo linijos
					//---------------------------
					//---------------------------------------------------
					// Masyvai
					//---------------------------------------------------
					double      p240[500];                                                             //kainu
					double      p240_diff[499];                                                        //kainu skirtumu
					double      p240_diff_Abs[499];                                                    //absoliuciu kainu skirtumu
					datetime    t240[500];                                                             //kainu laiko
					double      b240[500];                                                             //kainu barai				
					datetime    startTime240;                                                    //Laikas, nuo kurio prasides duomenu surinkimas
					int         StartBar240;                                                     //Baro Nr., nuo kurio prasides duomenu surinkimas
					//----------------------------------------
					//Surandam duomenu rinkimo pradzios laika
					//----------------------------------------
					n=iBars(NULL, TimeFrame[tf+2]);                                            //per du vyresnio TF baru skaicius
					k=0;
					for (i=1; i<n; i++) 
					{
						zz=iCustom(NULL, TimeFrame[tf+2], "ZigZag", dp, dv, bs, 0, i);
						if (zz!=0) 
						{
							k++;
							if (k==3) 
							{ 
								startTime240=iTime(NULL,TimeFrame[tf+2],i);                           //Laikas per du vyresnio TF nuo kurio prasides skaiciavimai
								Print("Skaiciavimo pradzios ieskosime +2 vyresniame TF   +++++++-M",TimeFrame[tf+2],"-+++++++");
								StartBar240=iBarShift(NULL,TimeFrame[tf],startTime240);                 //Baro Nr.esamo TF (M1)nuo kurio prasides skaiciavimai
								Print("Rasta skaiciavimo pradzia nuo   ",TimeToStr(startTime240, TIME_DATE|TIME_MINUTES));
								break;
							}
						}    
					}
					//------------------------------------------
					ii=0;
					for (i=1; i<StartBar240+2; i++) 
					{
						zz=iCustom(NULL,TimeFrame[tf],"ZigZag", dp, dv, bs,0,i);      
						if(zz!=0 /*&& zz!=EMPTY_VALUE*/)  
						{
							p240[ii]=zz;                                                              //zz ekstremumu kainu masyvo elementas su nenuline reiksme                                    
							t240[ii]=iTime(NULL, TimeFrame[tf], i);                                   //surasto baro laiko masyvo elementas su nenuline zz reiksme
							b240[ii]=i;                                                               //surastas baru masyvo elementas su nenuline zz reiksme            
							ii++;
						} 																    // end if(zz!=0 /*&& zz!=EMPTY_VALUE*/)
					} 																       //end for (i=1; i<StartBar; i++) 
					for(iii=0; iii<ii-1; iii++)
					{
						p240_diff[iii]=(p240[iii]-p240[iii+1])/Point;                                 //zz gretimu ekstremumu kainu skirtumo masyvo elementas 
						p240_diff_Abs[iii]=MathAbs(p240_diff[iii]);                                 //zz gretimu ekstremumu kainu absoliutaus skirtumo masyvo elementas
					} 																      //end for(iii=0; iii<ii-1; iii++)																					      
					ArrayResize(p240,ii);                                                        	//kainu
					ArrayResize(p240_diff,iii);                                                  	//kainu skirtumu
					ArrayResize(p240_diff_Abs,iii);                                              	//absoliuciu kainu skirtumu             
					ArrayResize(t240, ii);                                                       	//kainu laiko
					ArrayResize(b240, ii);                                                       	//kainu barai     
					Print("Elementu skaicius      ii=",ii,"     iii=",iii);
					//----------------------------------------
					//TL brezimas. ZZ spinduliai mazejantys
					//----------------------------------------
					if( //	p_diff[3]>0 &&                                                     //Jei 
						p240_diff_Abs[4]>p240_diff_Abs[3]*100/RayDiffPercent &&                  //
						p240_diff_Abs[3]*1.15>p240_diff_Abs[2] && 
						p240_diff_Abs[2]*1.15>p240_diff_Abs[1])
					{
						CurrLineTime240=iTime(NULL, TimeFrame[tf],0);
						if(CurrLineTime240>PrevLineTime240)
						{                               
							tStartLine1=t240[4];                                                    //Linijos pradzios laikas
							pStartLine1=p240[4];                                                      //Linijos pradzios kaina
							tEndLine1=iTime(NULL,TimeFrame[tf],0)+LineBarsUp*TimeFrame[tf]*60;                       //Linijos pabaigos laikas
							pEndLine1=EquationDirect(tStartLine1, pStartLine1, t240[2] , p240[2], tEndLine1); //Linijos pabaigos kaina                   
					      string nameM240_1="LineM240_1"+TimeToStr(tStartLine1,TIME_DATE|TIME_MINUTES);
					      
							ObjectCreate(nameM240_1, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameM240_1, OBJPROP_TIME1 , tStartLine1);
							ObjectSet   (nameM240_1, OBJPROP_PRICE1,pStartLine1);
							ObjectSet   (nameM240_1, OBJPROP_TIME2 , tEndLine1);
							ObjectSet   (nameM240_1, OBJPROP_PRICE2,pEndLine1);
							ObjectSet   (nameM240_1, OBJPROP_COLOR , c_M240);
							ObjectSet   (nameM240_1, OBJPROP_RAY   , false);
							ObjectSet   (nameM240_1, OBJPROP_STYLE , 0);
							ObjectSet   (nameM240_1, OBJPROP_WIDTH , width_M240);
							
							tStartLine2=t240[3];
							pStartLine2=p240[3];
							pEndLine2=EquationDirect(tStartLine2,pStartLine2, t240[1], p240[1], tEndLine1);               //???????????
                     string nameM240_2="LineM240_2"+TimeToStr(tStartLine2,TIME_DATE|TIME_MINUTES);
                     
							ObjectCreate(nameM240_2, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameM240_2, OBJPROP_TIME1 , tStartLine2);
							ObjectSet   (nameM240_2, OBJPROP_PRICE1, pStartLine2);
							ObjectSet   (nameM240_2, OBJPROP_TIME2 , tEndLine1);
							ObjectSet   (nameM240_2, OBJPROP_PRICE2, pEndLine2);
							ObjectSet   (nameM240_2, OBJPROP_COLOR , c_M240);
							ObjectSet   (nameM240_2, OBJPROP_RAY   , false);
							ObjectSet   (nameM240_2, OBJPROP_STYLE , 0);
							ObjectSet   (nameM240_2, OBJPROP_WIDTH , width_M240);
                  
							PrevLineTime240=tEndLine1;
						}	
					}																	//end if(.....p_diff_Abs[3]>p_diff_Abs[2]*100/RayDiffPercent && ...)
					PrevZZ240=CurrZZ240;
				} 																		//end if(Curr_zz1!=Prev_zz1)
				PrevTime240 = CurrTime240;
			}																	// end if (CurrTime1!=PrevTime1)
		}		
		if(tf == 6 && tf_M1440)
		{
            Print("---------------------------------------------------M1440_tf=",TimeFrame[tf],"----------------------------------------");
            int mn1440 = MagicNumber + TimeFrame[tf];
            //---------------------------
            //NewTick
            //---------------------------
            


            //---------------------------
            //NewBar M1440
            //---------------------------
            CurrTime1440 = iTime(NULL,TimeFrame[tf],1);
            if (CurrTime1440!=PrevTime1440)
            {
               Print("M1440_newTime=",TimeToStr(CurrTime1440), "*******Nauja bara radom*********");              
               //---------------------------
               //NewZigZag  M1440
               //---------------------------
               n=iBars(NULL, TimeFrame[tf]); 	                                       	 //esamu baru skaicius ekrane
               k=0;				                                                       	    //rastu ekstremumu skaicius
               for (i=1; i<n; i++) 
                { 
            	    zz=iCustom(NULL, TimeFrame[tf], "ZigZag", dp, dv, bs, 0, i);
                    if (zz!=0) 
                    {                	
                	    k++;
                        if (k==2)			                                          	     //jei rasti du ekstremumai 
                        {
                           CurrZZ1440 = zz;
                           break;
                        }
                    }															           //end (zz1!=0)
                }             																	              //end for(i=1; i<k; i++) 
				if(CurrZZ1440!=PrevZZ1440)
				{
					Print("M240_newZigZag=",CurrZZ240, "-*-*-*-*-*-Nauja ZigZag radom-*-*-*-*-*-*"); 
					//---------------------------
					//atsiradus naujam zz ekstremumui 
					//renkami duomenys i masyvus ir 
					//breziamos zz kanalo linijos
					//---------------------------
					//---------------------------------------------------
					// Masyvai
					//---------------------------------------------------
					double      p1440[500];                                                             //kainu
					double      p1440_diff[499];                                                        //kainu skirtumu
					double      p1440_diff_Abs[499];                                                    //absoliuciu kainu skirtumu
					datetime    t1440[500];                                                             //kainu laiko
					double      b1440[500];                                                             //kainu barai				
					datetime    startTime1440;                                                    //Laikas, nuo kurio prasides duomenu surinkimas
					int         StartBar1440;                                                     //Baro Nr., nuo kurio prasides duomenu surinkimas
					//----------------------------------------
					//Surandam duomenu rinkimo pradzios laika
					//----------------------------------------
					n=iBars(NULL, TimeFrame[tf+2]);                                            //per du vyresnio TF baru skaicius
					k=0;
					for (i=1; i<n; i++) 
					{
						zz=iCustom(NULL, TimeFrame[tf+2], "ZigZag", dp, dv, bs, 0, i);
						if (zz!=0) 
						{
							k++;
							if (k==3) 
							{ 
								startTime1440=iTime(NULL,TimeFrame[tf+2],i);                           //Laikas per du vyresnio TF nuo kurio prasides skaiciavimai
								Print("Skaiciavimo pradzios ieskosime +2 vyresniame TF   +++++++-M",TimeFrame[tf+2],"-+++++++");
								StartBar1440=iBarShift(NULL,TimeFrame[tf],startTime1440);                 //Baro Nr.esamo TF (M1)nuo kurio prasides skaiciavimai
								Print("Rasta skaiciavimo pradzia nuo   ",TimeToStr(startTime1440, TIME_DATE|TIME_MINUTES));
								break;
							}
						}    
					}
					//------------------------------------------
					ii=0;
					for (i=1; i<StartBar1440+2; i++) 
					{
						zz=iCustom(NULL,TimeFrame[tf],"ZigZag", dp, dv, bs,0,i);      
						if(zz!=0 /*&& zz!=EMPTY_VALUE*/)  
						{
							p1440[ii]=zz;                                                              //zz ekstremumu kainu masyvo elementas su nenuline reiksme                                    
							t1440[ii]=iTime(NULL, TimeFrame[tf], i);                                   //surasto baro laiko masyvo elementas su nenuline zz reiksme
							b1440[ii]=i;                                                               //surastas baru masyvo elementas su nenuline zz reiksme            
							ii++;
						} 																    // end if(zz!=0 /*&& zz!=EMPTY_VALUE*/)
					} 																       //end for (i=1; i<StartBar; i++) 
					for(iii=0; iii<ii-1; iii++)
					{
						p1440_diff[iii]=(p1440[iii]-p1440[iii+1])/Point;                                 //zz gretimu ekstremumu kainu skirtumo masyvo elementas 
						p1440_diff_Abs[iii]=MathAbs(p1440_diff[iii]);                                 //zz gretimu ekstremumu kainu absoliutaus skirtumo masyvo elementas
					} 																      //end for(iii=0; iii<ii-1; iii++)																					      
					ArrayResize(p1440,ii);                                                        	//kainu
					ArrayResize(p1440_diff,iii);                                                  	//kainu skirtumu
					ArrayResize(p1440_diff_Abs,iii);                                              	//absoliuciu kainu skirtumu             
					ArrayResize(t1440, ii);                                                       	//kainu laiko
					ArrayResize(b1440, ii);                                                       	//kainu barai     
					Print("Elementu skaicius      ii=",ii,"     iii=",iii);
					//----------------------------------------
					//TL brezimas. ZZ spinduliai mazejantys
					//----------------------------------------
					if( //	p_diff[3]>0 &&                                                     //Jei 
						p1440_diff_Abs[4]>p1440_diff_Abs[3]*100/RayDiffPercent &&                  //
						p1440_diff_Abs[3]*1.15>p1440_diff_Abs[2] && 
						p1440_diff_Abs[2]*1.15>p1440_diff_Abs[1])
					{
						CurrLineTime1440=iTime(NULL, TimeFrame[tf],0);
						if(CurrLineTime1440>PrevLineTime1440)
						{                               
							tStartLine1=t1440[4];                                                    //Linijos pradzios laikas
							pStartLine1=p1440[4];                                                      //Linijos pradzios kaina
							tEndLine1=iTime(NULL,TimeFrame[tf],0)+LineBarsUp*TimeFrame[tf]*60;                       //Linijos pabaigos laikas
							pEndLine1=EquationDirect(tStartLine1, pStartLine1, t1440[2] , p1440[2], tEndLine1); //Linijos pabaigos kaina                   
					      string nameM1440_1="LineM240_1"+TimeToStr(tStartLine1,TIME_DATE|TIME_MINUTES);
					      
							ObjectCreate(nameM1440_1, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameM1440_1, OBJPROP_TIME1 , tStartLine1);
							ObjectSet   (nameM1440_1, OBJPROP_PRICE1,pStartLine1);
							ObjectSet   (nameM1440_1, OBJPROP_TIME2 , tEndLine1);
							ObjectSet   (nameM1440_1, OBJPROP_PRICE2,pEndLine1);
							ObjectSet   (nameM1440_1, OBJPROP_COLOR , c_M1440);
							ObjectSet   (nameM1440_1, OBJPROP_RAY   , false);
							ObjectSet   (nameM1440_1, OBJPROP_STYLE , 0);
							ObjectSet   (nameM1440_1, OBJPROP_WIDTH , width_M1440);
							
							tStartLine2=t1440[3];
							pStartLine2=p1440[3];
							pEndLine2=EquationDirect(tStartLine2,pStartLine2, t1440[1], p1440[1], tEndLine1);               //???????????
                     string nameM1440_2="LineM240_2"+TimeToStr(tStartLine2,TIME_DATE|TIME_MINUTES);
                     
							ObjectCreate(nameM1440_2, OBJ_TREND, 0, 0,0, 0,0);
							ObjectSet   (nameM1440_2, OBJPROP_TIME1 , tStartLine2);
							ObjectSet   (nameM1440_2, OBJPROP_PRICE1, pStartLine2);
							ObjectSet   (nameM1440_2, OBJPROP_TIME2 , tEndLine1);
							ObjectSet   (nameM1440_2, OBJPROP_PRICE2, pEndLine2);
							ObjectSet   (nameM1440_2, OBJPROP_COLOR , c_M1440);
							ObjectSet   (nameM1440_2, OBJPROP_RAY   , false);
							ObjectSet   (nameM1440_2, OBJPROP_STYLE , 0);
							ObjectSet   (nameM1440_2, OBJPROP_WIDTH , width_M1440);
                  
							PrevLineTime1440=tEndLine1;
						}	
					}																	//end if(.....p_diff_Abs[3]>p_diff_Abs[2]*100/RayDiffPercent && ...)
					PrevZZ1440=CurrZZ1440;
				} 																		//end if(Curr_zz1!=Prev_zz1)
				PrevTime1440 = CurrTime1440;
			}																	// end if (CurrTime1!=PrevTime1)
		}	
		if(tf == 7 && tf_M10080)
		{
            int mn10080 = MagicNumber + TimeFrame[tf];
            Print("100801-tf=",TimeFrame[tf]);
            //---------------------------
            //NewTick
            //---------------------------
            
            //---------------------------
            //NewBar W1
            //---------------------------
             CurrTime10080 = iTime(NULL,TimeFrame[tf],1);
            if (CurrTime10080!=PrevTime10080)
            {
            	Print(".......................M10080.......................newTime",mn10080, "   ",TimeToStr(CurrTime10080));
				


				PrevTime10080 = CurrTime10080;
            }
            //---------------------------
            //NewZigZag W1
            //---------------------------
             

		}
    }																			 //end for(tf=1; tf<7; tf++)
  
//----
   return(0);
   }																								// end start
//+------------------------------------------------------------------+
//Funkcijos
//--------------------------------------------------------------------
double EquationDirect(double x1, double y1, double x2, double y2, double x) 
{
  	if (x2==x1) 		return(y1);
  	return(((x-x1)*(y2-y1)/(x2-x1))+y1);
}
//********************************************************************	
datetime GetExtremumZZ_2TF_Bars(string sy="", int tf1=0, int tf2=0, int ne=0, int dp=12, int dv=5, int bs=3) 
{
  if (sy=="" || sy=="0") sy=Symbol();
  double zz1,  zz2, p1, p2;
  int    i, k1=iBars(sy, tf1), ke=0;
  int    j;
  datetime t;
  
  for (i=1; i<k1; i++) 
  {
    zz1=iCustom(sy, tf1, "ZigZag", dp, dv, bs, 0, i);
    if (zz1!=0) 
    {
      ke++;
      if (ke>ne) 
         {p1=zz1;datetime t1=iTime(sy,tf1,i);}
    }
    
  }
  Print("                                  p1   " ,p1);
  Print("                                  t1   ", TimeToStr(t1,  TIME_DATE|TIME_MINUTES));
  for (j=1; j<Bars; j++) 
  {
    zz2=iCustom(sy, tf2, "ZigZag", dp, dv, bs, 0, j);
    if (zz2!=0) 
    {
      p2=zz2;
      Print("p2=   ",p2);
      t=iTime(sy, tf2, j);
      if(p1==p2)
      {
         Print("skaiciavimo pradzia nuo   ",TimeToStr(t, TIME_DATE|TIME_MINUTES));
         return(t);
      }
    }
  }
  return(0);
}
//------------------------------------------





